Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.flagstone.transform
Class FSImport

    java.lang.Object
      com.flagstone.transform.FSTransformObject
          com.flagstone.transform.FSMovieObject
              com.flagstone.transform.FSImport

All Implemented Interfaces:
  java.lang.Cloneable

    public class FSImport

extends FSMovieObject

FSImport is used to import shapes and other objects from another Flash file.

Since the identifier for an object is only unique within a given Flash file, imported objects are referenced by a name assigned when the object is exported.

Attribute | Description
--- | ---
type | Identifies the data structure when it is encoded. Read-only.
url | The URL of the file containing the object to be imported. The URL must be in the same sub-domain and relative to the URL of the Flash file containing the file importing the object.
objects | A HashTable containing key-value pairs where the key is the identifier of the object being imported and the value is name assigned to the object when it was exported into a Flash file.

To provide a degree of security the Flash Player will only import files that originate from the same domain as the file that it is currently playing. For example if the Flash file being shown was loaded from www.mydomain.com/flash.swf then the file contains the exported objects must reside somewhere at www.mydomain.com. This prevents a malicious Flash file from loading files from an unknown third party.

# Examples

To export an object from a Flash file:

      FSDefineShape shape = new FSDefineShape(...);

      movie.add(shape);
      movie.add(new FSExport(shape.getIdentifier(), "Shape"));

The object can then be imported:

     movie.add(new FSImport("exportFile.swf", movie.newIdentifier(), "Shape"));

# History

The FSImport class represents the ImportAssets data structure in the Macromedia Flash (SWF) File Format Specification. It was introduced in Flash 5.

Field Summary

Fields inherited from class com.flagstone.transform.FSMovieObject
`ButtonColorTransform, ButtonSound, DefineBitsPtr, DefineButton, DefineButton2, DefineFont, DefineFont2, DefineImage, DefineImage2, DefineJPEGImage, DefineJPEGImage2, DefineJPEGImage3, DefineMorphShape, DefineMovieClip, DefineShape, DefineShape2, DefineShape3, DefineSound, DefineText, DefineText2, DefineTextField, DefineVideo, DoAction, EnableDebugger, EnableDebugger2, Export, extendLength, FontInfo, FontInfo2, FrameLabel, Free, Import, Initialize, JPEGTables, length, LimitScript, PathsArePostscript, PlaceObject, PlaceObject2, Protect, QuicktimeMovie, RemoveObject, RemoveObject2, SerialNumber, SetBackgroundColor, ShowFrame, SoundStreamBlock, SoundStreamHead, SoundStreamHead2, StartSound, TabOrder, type, VideoFrame`

Constructor Summary
`FSImport(FSCoder coder)` Construct an FSImport object, initialising it with values decoded from an encoded object.
`FSImport(FSImport obj)` Constructs an FSImport object by copying values from an existing object.
`FSImport(java.lang.String aUrl, int anIdentifier, java.lang.String aString)` Constructs an FSImport object that imports an object from the specified file.

Method Summary
`void` | `add(int anIdentifier, java.lang.String aString)` Adds the identifier and name to the list of objects to be imported.
`void` | `appendDescription(java.lang.StringBuffer buffer, int depth)` AppendDescription is used to present a string description of the object including all nested objects up to a specified depth.
`void` | `decode(FSCoder coder)`
`void` | `encode(FSCoder coder)`
`boolean` | `equals(java.lang.Object anObject)` Returns true if anObject is equal to this one.
`java.util.Hashtable` | `getObjects()` Gets the table of objects to be imported.
`java.lang.String` | `getUrl()` Gets the URL of the file containing the object to be imported.
`int` | `length(FSCoder coder)`
`void` | `setObjects(java.util.Hashtable aTable)` Sets the table of objects to be imported.
`void` | `setUrl(java.lang.String aString)` Sets the URL of the file containing the imported objects.

Methods inherited from class com.flagstone.transform.FSMovieObject
`getType`

Methods inherited from class com.flagstone.transform.FSTransformObject
`clone, name, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FSImport

    public FSImport(FSCoder coder)

  Construct an FSImport object, initialising it with values decoded from an encoded object.

  Parameters:
    `coder` - an FSCoder containing the binary data.

### FSImport

    public FSImport(java.lang.String aUrl,
                    int anIdentifier,
                    java.lang.String aString)

  Constructs an FSImport object that imports an object from the specified file. The exported object is referenced by a name assigned to it when it was exported. The newly imported object must be assigned an identifier that is unique within the movie the object is imported into. Limited security is provided by requiring that the URL must be in the same domain or sub-domain as the URL of the movie which contains this object.

  Parameters:
    `aUrl` - the URL referencing the file to be imported.
    `anIdentifier` - the identifier of the object to be exported.
    `aString` - the name of the exported object to allow it to be referenced.

### FSImport

    public FSImport(FSImport obj)

  Constructs an FSImport object by copying values from an existing object.

  Parameters:
    `obj` - an FSImport object.

Method Detail

### add

    public void add(int anIdentifier,
                    java.lang.String aString)

  Adds the identifier and name to the list of objects to be imported.

  Parameters:
    `anIdentifier` - the identifier of the object to be imported.
    `aString` - the name of the imported object to allow it to be referenced.

### getUrl

    public java.lang.String getUrl()

  Gets the URL of the file containing the object to be imported. Limited security is provided by requiring that the URL must be in the same domain or sub-domain as the URL of the movie which contains this object.

  Returns:
    the URL of the file containing the object to be imported.

### getObjects

    public java.util.Hashtable getObjects()

  Gets the table of objects to be imported.

  Returns:
    the table of imported objects.

### setUrl

    public void setUrl(java.lang.String aString)

  Sets the URL of the file containing the imported objects. The URL must be in the same sub-domain and relative to the URL of the file containing the FSImport object.

  Parameters:
    `aString` - a URL relative to the URL of the file containing the FSImport object.

### setObjects

    public void setObjects(java.util.Hashtable aTable)

  Sets the table of objects to be imported.

  Parameters:
    `aTable` - the table of objects being imported.

### equals

    public boolean equals(java.lang.Object anObject)

  Description copied from class: `FSMovieObject`
  Returns true if anObject is equal to this one. Objects are considered equal if they would generate identical binary data when they are encoded to a Flash file.

  Overrides:
    `equals` in class `FSMovieObject`
  Returns:
    true if this object would be identical to anObject when encoded.

### appendDescription

    public void appendDescription(java.lang.StringBuffer buffer,
                                  int depth)

  Description copied from class: `FSTransformObject`
  AppendDescription is used to present a string description of the object including all nested objects up to a specified depth. This method provide a more controlled way of creating a string representation of an object since large objects such as font or shape definitions can contain dozens of nested objects. The representation of the object is appended to the StringBuffer, showing the name of the class and values of the attributes it contains. If the object contains any attributes that are objects then the object graph will be traversed up to the specified depth. If objects are nested at a level less than specified depth then the full string representation of the object is displayed. For objects at the specified depth only the name of the class is displayed. Any objects below this depth are not displayed.

  Overrides:
    `appendDescription` in class `FSMovieObject`
  Parameters:
    `buffer` - a StringBuffer to which the description of each object is appended.
    `depth` - the maximum level of nesting up to which objects will be displayed.

### length

    public int length(FSCoder coder)

  Overrides:
    `length` in class `FSMovieObject`

### encode

    public void encode(FSCoder coder)

  Overrides:
    `encode` in class `FSMovieObject`

### decode

    public void decode(FSCoder coder)

  Overrides:
    `decode` in class `FSMovieObject`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD